# Copyright (C) 2008 by Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>
#        
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#    
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#   
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import clr

import System
import System.Collections.Generic
import System.Reflection
import System.IO
import sys

from System import *
from System.Collections.Generic import *
from System.Reflection import *
from System.IO import *

sys.path.append(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location))

# HACK - Do this a better way later
sys.path.append('/usr/lib/python2.4')
sys.path.append('/usr/lib/python2.4/site-packages')

import site

clr.AddReference('MonoDevelop.VersionControl.Bazaar.dll')
import MonoDevelop.VersionControl.Bazaar
from MonoDevelop.VersionControl.Bazaar import *

import bzrlib
from bzrlib import api



class BazaarLibClientReal(MonoDevelop.VersionControl.Bazaar.BazaarClient):
	# public abstract string Version{ get; }
	@property
	def Version(self):
		ver = '.'.join(map(lambda x: str(x), api.get_current_api_version(None)))
		print('Version: ' + ver)
		return ver

	# public abstract IList<string> List (string path, bool recurse, ListKind kind);
	def List(self, path, recurse, kind):
		print('List: ' + path + ' ' + recurse + ' ' + kind)
		files = List[str]()
		
		return files

	# public abstract IList<LocalStatus> Status (string path, BazaarRevision revision);
	def Status(self, path, revision):
		print('Status: ' + path + ' ' + revision)
		return List[LocalStatus]()

	# public abstract string GetPathUrl (string path);
	def GetPathUrl(self, path):
		print('GetPathUrl: ' + path)
		return ''

	# public abstract void Update (string localPath, bool recurse, IProgressMonitor monitor);
	def Update(self, localPath, recurse, monitor):
		print('Update: ' + localPath + ' ' + recurse + ' ' + monitor)

	# public abstract void Revert (string localPath, bool recurse, IProgressMonitor monitor, BazaarRevision toRevision);
	def Revert(self, localPath, recurse, monitor, toRevision):
		print('Revert: ' + localPath + ' ' + recurse + ' ' + monitor + ' ' + toRevision)

	# public abstract void Add (string localPath, bool recurse, IProgressMonitor monitor);
	def Add(self, localPath, recurse, monitor):
		print('Add: ' + localPath + ' ' + recurse + ' ' + monitor)

	# public abstract void Checkout (string url, string targetLocalPath, BazaarRevision rev, bool recurse, IProgressMonitor monitor);
	def Checkout(self, url, targetLocalPath, rev, recurse, monitor):
		print('Checkout: ' + url + ' ' + targetLocalPath + ' ' + rev + ' ' + recurse + ' ' + monitor)

	# public abstract string GetTextAtRevision (string path, BazaarRevision rev);
	def GetTextAtRevision(self, path, rev):
		print('GetTextAtRevision: ' + path + ' ' + rev)
		return ''

	# public abstract BazaarRevision[] GetHistory (BazaarRepository repo, string localFile, BazaarRevision since);
	def GetHistory(self, repo, localFile, since):
		print('GetHistory: ' + repo + ' ' + localFile + ' ' + since)
		return Array[BazaarRevision]()
		
	# public abstract void Merge (string path, BazaarRevision start, BazaarRevision end, IProgressMonitor monitor);
	def Merge(self, path, start, end, monitor):
		print('Merge: ' + path + ' ' + start + ' ' + end + ' ' + monitor)

	# public abstract void Push (string pushLocation, string localPath, IProgressMonitor monitor);
	def Push(self, pushLocation, localPath, monitor):
		print('Push: ' + pushLocation + ' ' + localPath + ' ' + monitor)

	# public abstract void Commit (ChangeSet changeSet, IProgressMonitor monitor);
	def Commit(self, changeSet, monitor):
		print('Commit: ' + changeSet + ' ' + monitor)

	# public abstract DiffInfo[] Diff (string basePath, string[] files);
	def Diff(self, basePath, files):
		print('Diff: ' + basePath + ' ' + files)
		return Array[DiffInfo]()

	# public abstract void Remove (string path, bool force, IProgressMonitor monitor);
	def Remove(self, path, force, monitor):
		print('Remove: ' + path + ' ' + force + ' ' + monitor)
